///	\file	defs.h
///	\author	Rob
///


#ifdef WIN32
#pragma once
#endif


#ifndef MATHS_DEFS_H_INCLUDED
#define MATHS_DEFS_H_INCLUDED

#ifndef IN
#define IN
#endif

#ifndef OUT
#define OUT
#endif

///	This typedef controls the data type used to store data in the maths lib.
///	This allows you to change this one line to say, double, and it will change
///	the whole maths lib so it uses double precision numbers.
///
typedef float XReal;

///	This is the epsilon value used for floating point comparisons
const float g_vecEpsilon = 0.001f;

///	PI / 180 constant
const float PI_OVER_180 = 0.017453292519943295769236907684886f;

///	PI constant
const float PI          = 3.1415926535897932384626433832795f;

/// shouldn't use the == operator for floats, so I've hacked together this macro instead
/// 
#define FCOMPARE(X_,Y_) (((X_)>((Y_) - g_vecEpsilon)) && ( (X_) < ((Y_)-g_vecEpsilon)))


#endif
