// test prog for maths lib
//

// use ogl for matrix stuff
//
#ifdef __APPLE__
	#include <GLUT/glut.h>
#else
	#include <GL/glut.h>
#endif
#include <iostream>
#include <stdlib.h>

#include "EulerAngles.h"
#include "Line.h"
#include "Matrix.h"
#include "Plane.h"
#include "Quaternion.h"
#include "Sphere.h"
#include "Transform.h"
#include "Vector.h"

void GL_Display();

int main(int a,char **v )
{
	glutInit(&a,v);
	glutInitDisplayMode(GLUT_RGB|GLUT_SINGLE);
	glutInitWindowSize(640,480);
	glutCreateWindow("MOOO");
	glutDisplayFunc(GL_Display);
	glutMainLoop();
	return 0;
}

void ReadDisplay()
{
	float m[16];
	glFlush();
	glGetFloatv(GL_MODELVIEW_MATRIX,m);
	for(int i=0;i<16;++i)
	{
		if( i>0 && i%4 == 0 )
		{
			std::cout << "\n" << m[i];
		}
			
		else
		{	
			std::cout << " " << m[i];
		}		
	}
	std::cout << std::endl;
}

void GL_Display()
{
	glClear(GL_COLOR_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	
	XMatrix a;
		
	glScalef(2,2,2);
	
	ReadDisplay();
	
	a.Scale(2,2,2);
	
	std::cout  << "\n"<< a << "\n" << "\n";
	
	a.Inverse();
	
	std::cout  << "\n"<< a << "\n" << "\n";
	
	
	glLoadIdentity();
	a.Identity();
	
	glRotatef(45,1,0,0);
	
	ReadDisplay();
	
	a.RotateX(45);
	
	std::cout  << "\n"<< a << "\n" << "\n";
	

	glLoadIdentity();
	a.Identity();
	
	glRotatef(45,0,1,0);
	
	ReadDisplay();
	
	a.RotateY(45);
	
	std::cout  << "\n"<< a << "\n" << "\n";
	

	glLoadIdentity();
	a.Identity();
	
	glRotatef(45,0,0,1);
	
	ReadDisplay();
	
	a.RotateZ(45);
	
	std::cout  << "\n"<< a << "\n" << "\n";
	
	glLoadIdentity();
	a.Identity();
	
	glRotatef(45,1,0,0);
	glRotatef(45,0,1,0);
	glRotatef(45,0,0,1);
	glScalef(1,2,3);
	
	ReadDisplay();
	
	a.RotateX(45);
	a.RotateY(45);
	a.RotateZ(45);
	a.Scale(1,2,3);
	
	std::cout  << "\n"<< a << "\n" << "\n";
	
	a.Transpose();
	
	std::cout  << "\n"<< a << "\n" << "\n";
	

	
	glLoadIdentity();
	a.Identity();
	
	glRotatef(45,1,0,0);
	glRotatef(45,0,1,0);
	glRotatef(45,0,0,1);
	glScalef(1,2,3);
	glTranslatef(1,2,3);
	
	ReadDisplay();
	
	a.RotateX(45);
	a.RotateY(45);
	a.RotateZ(45);
	a.Scale(1,2,3);
	a.Translate(1,2,3);
	
	std::cout  << "\n"<< a << "\n" << "\n";	
	
	glLoadIdentity();
	a.Identity();
	
	a.RotateX(45);
	a.RotateY(45);
	a.RotateZ(45);
	a.Scale(1,2,3);
	a.Translate(1,2,3);
	
	
	glMultMatrixf( a.data );
	
	ReadDisplay();
	std::cout  << "\n"<< a << "\n" << "\n";	
	
	glLoadIdentity();
	a.Identity();
	
	glRotatef(45,1,0,0);
	glRotatef(45,0,1,0);
	glRotatef(45,0,0,1);
	glScalef(1,2,3);
	glTranslatef(1,2,3);
		
	glGetFloatv( GL_MODELVIEW_MATRIX, a.data );
	
	ReadDisplay();
	std::cout  << "\n"<< a << "\n" << "\n";	
	
	glLoadIdentity();
	a.Identity();
	
	XEulerAngles ea(25,35,45);
	glRotatef(25,1,0,0);
	glRotatef(35,0,1,0);
	glRotatef(45,0,0,1);
	XMatrix MM = ea.AsMatrix();
	ReadDisplay();
	std::cout  << "\n"<< MM << "\n" << "\n";
	
	XQuaternion Q(MM);
	
	std::cout << Q << std::endl;
	
	MM = ea.AsMatrix();
	
	std::cout  << "\n"<< MM << "\n" << "\n";
	
	exit(0);	
}
